// score:100
// runs in O(Q)
// uses a fact from https://en.wikipedia.org/wiki/Lucas's_theorem#Consequence that states:
// A binomial coefficient ( m n ) {\tbinom {m}{n}} is divisible by a prime p if and only if at least one of the base p digits of n is greater than the corresponding digit of m.
#include <bits/stdc++.h>
using namespace std;

int main()
{
	cin.tie(0);cout.tie(0);
	ios_base::sync_with_stdio(false);
	long long Q, N, M, K;
        cin >> N >> Q;
	stringstream ssout;
	while(Q--){
		cin >> K >> M;
		ssout << (char)('0'+((M&(N-K))==(N-K))) << '\n'; // to compute \binom{M}{N-K} mod 2, just check if N-k has any bit set that M hasn't
	}
	cout << ssout.str();
	return 0;
}
